
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP和分布式Memcache的一个小问题 单点故障 / iVAN</title>

    <meta name="description" content="PHP和分布式Memcache的一个小问题 单点故障 这几天做某个产品的时候遇到一个小问题,现象比较诡异 产品用了两台分布式的memcached服务器 某一个计数器取回来的数偶尔会不对,最后定位在php memcache client的failover机制上面. 我们知道,在memcached分布式环境下,某一个key是通过hash计算,分配到某一个memcached上面的 如果php.ini里面 memcache.allow_failover = 1的时候,在分布式环境下,某一台memcached出问题的话,会自动到其他的memcached尝试">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PHP和分布式Memcache的一个小问题 单点故障</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>这几天做某个产品的时候遇到一个小问题，现象比较诡异</p>
<p>产品用了两台分布式的memcached服务器</p>
<p>某一个计数器取回来的数偶尔会不对，最后定位在php memcache client的failover机制上面。</p>
<p>我们知道，在memcached分布式环境下，某一个key是通过hash计算，分配到某一个memcached上面的</p>
<p>如果php.ini里面 memcache.allow_failover = 1的时候，在分布式环境下，某一台memcached出问题的话，会自动到其他的memcached尝试</p>
<p>就会出现上面的问题，原因如下:</p>
<p>这个key是hash到服务器A的，但是服务器A正好一瞬间连不上(网络或者其他问题)，PHP就会去另一台服务器B去尝试。</p>
<p>经过很偶然发生的网络问题和很多次increment操作，有可能两台服务器上面都有这个key，而且值不一样……</p>
<p>get的时候有可能取到不同的值</p>
<p>如果对数据一致性要求很严格的话，可以关掉这个参数 memcache.allow_failover = 0，嗯，问题解决</p>
<p> </p>
<p><strong>虽然Memcached</strong><strong>作为一个分布式缓存数据服务，但是每个服务之间根本没有进行相互通信，这里可能与 我理解的分布式有点区别</strong>，可能是我才疏学浅，也可能是每个人思考问题的角度不同。<strong>Memcached 客户端就是通过一种分布式<a href="http://lib.csdn.net/base/31" rel="external nofollow noreferrer">算法</a>将数据保存到不同的Memcached服务器上，将数据进行缓存。</strong></p>
<p>Memcached分布式环境下，每个服务器端本身没有相互相连的关系，数据分布其实是由客户端来维持的（通俗点说，是客户端按照自己的分布算法， 将数据分配 给指定的服务端去存储，取值的时候，客户端再找指定的服务器拿数据。任何环境下，服务端都不可能主动去找客户端拿“东西”或者去操作客户端。B/S模式也 是的，web服务器不可能主动找浏览器拿东西，更不可能对浏览器端做任何操作）。memcached的服务端更不会这么聪明，自动去查找、匹配当前环境 中分布的其他服务器。</p>
<p>而且，据我所知，Memcached本身并没有为集群提供真的高可用方案，因为我个人认为，使用集群环境，通常是为了满足以下的需求：</p>
<p>1.压力分载 （负载均衡）    2.失效转发（故障转移）。</p>
<p>而memcached本身并不具备这两点，这对于以“分布式缓存”号称的memcached来说，是非常致命的。<br />
<br />  <strong>现象描述：</strong><br />
    在客户端连接的部分写入多个服务器端的ip地址，客户端将会自动的把缓存数据分布的放在每个不同的机器上</p>
<p><a href="http://www.javabloger.com/images/article_pic/memcached/masd-1.png" rel="external nofollow noreferrer">查看大图请点击这里</a></p>
<p><strong>现象后果：</strong><br />
    如果其中一个缓存节点的机器down机，那么客户端存入的缓存数据将会丢失一部分，就是图中红色字体描述的“Losed 33% Cache Data”，也就是说那部分数据彻底没有了！如果是用户的关键性信息那么就玩大了<br /><a href="http://www.javabloger.com/images/article_pic/memcached/masd-2.png" rel="external nofollow noreferrer">查看大图请点击这里</a></p>
<p><strong>解决方案1：本地备份缓存</strong><br />
    在本地放一份缓存，同时也在分布式Memcached上放一份缓存，如果当其中一台节点当机了，客户端程序直接读取本地的缓存，本地客户端维护一个 HashMap即可，这样的方案虽然很简陋，但是可以满足一部分场景的需要，当你很急需的时候可以作为临时方案暂时替代一下。</p>
<p><strong>解决方案2：采用缓存代理服务器</strong><br />
    采用 <a href="http://code.google.com/p/memagent/wiki/HowMagentWorks" rel="external nofollow noreferrer">Magent </a>缓存代理，防止单点现象，缓存代理也可以做备份，通过客户端连接到缓存代理服务器，缓存代理服务器连接缓存服务器，缓存代理服务器可以连接多台Memcached机器可以将每台Memcached机器进行数据同步。这样的<a href="http://lib.csdn.net/base/16" rel="external nofollow noreferrer">架构</a>比较完善了，如果其中一台缓存代理服务器down机，系统依然可以继续工作，如果其中一台Memcached机器down掉，数据不会丢失并且可以保证数据的完整性 <br /><a href="http://www.javabloger.com/images/article_pic/memcached/masd-4.png" rel="external nofollow noreferrer">查看大图请点击这里</a></p>
<p>还是那句话：没有任何架构是最完美的，只是最合适的，任何架构都不可能一步到位，都是经过一步一步演变过来的。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-13 23:51:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/phpmemcached/" title="PHPmemcached">PHPmemcached</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PHP和分布式Memcache的一个小问题 单点故障的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mydg5Zb.html" rel="bookmark">如何打造一个小而精的电商网站架构？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文大纲: 1. 小型电商网站的架构 2. 日志与监控系统的解决方案 3. 构建数据库的主从架构 4. 基于共享存储的图片服务器架构 5. 移动M站建设 6. 系统容量预估 7. 缓存系统      一.小型电商网站的架构     刚从传统软件行业进入到电商企业时,觉得电商网站没有什么技术含量,也没有什么门槛,都是一些现有的东西堆积木似的堆出来罢了.然而,真正进入到这个行业之后,才发现并非如此.有人说过,好的架构,是演化出来的,电商网站的架构也是如此.现在好的电商网站,看似很复杂,很牛逼,其实也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ2me6z.html" rel="bookmark">电商总结（八）如何打造一个小而精的电商网站架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面写过一些电商网站相关的文章,这几天有时间,就把之前写得网站架构相关的文章,总结整理一下.把以前的一些内容就连贯起来,这样也能系统的知道,一个最小的电商平台是怎么一步步搭建起来的.对以前的文章感兴趣的朋友可以看这个,http://www.cnblogs.com/zhangweizhong/category/879056.html   本文大纲: 1. 小型电商网站的架构 2. 日志与监控系统的解决方案 3. 构建数据库的主从架构 4. 基于共享存储的图片服务器架构 5. 移动M站建设 6. 系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xpnxmOb.html" rel="bookmark">前端-用php和mysql为我们实验室建立一个小网站，请问有没有合适的模板源码？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 用php和mysql为我们实验室建立一个小网站,请问有没有合适的模板源码? 自己在chinaz上下载了几个,但是不尽人意,希望有路过的朋友能够提供帮助,只有建立一个链接数据库的小网站,不用线上上运行,所以模板不用太复杂,前端有了就好,谢谢 解决方案 你应该说明网站用途,根据用途可以决定里的要用什么,只链接数据库使用phpadmin就好 解决方案二: 这样谁说你更想要的是前端的页面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YbKkeAb.html" rel="bookmark">js浏览器-javascript中的一个小问题（浏览器问题）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 javascript中的一个小问题(浏览器问题) 求助 javascript中的一个小问题&lt; html&gt; &lt;head&gt; &lt;title&gt;Ajax 简单的服务器请求 &lt;script type=&quot;&quot;text/javascript&quot;&quot;&gt; var xmlobj; function CreateXMLHttpRequest() { if(window.ActiveXObject) //如果当前浏览器支持ActiveXOb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMq8Beb.html" rel="bookmark">音频-我用java写了一个小游戏，想插入背景音乐但不太会，求指教</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我用java写了一个小游戏,想插入背景音乐但不太会,求指教 package text; import java.io.*; import javax.sound.sampled.*; public class text { public static void main(String[] args) { // TODO Auto-generated method stub //创建一个实例 AePlayWave apw = new AePlayWave(&quot;G:\照片\Sleep Awa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boRXvz.html" rel="bookmark">结果是什么啊-一个小程序，求解答啊</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 一个小程序,求解答啊 在别人文章里看到的程序 程序的输出结果是什么,why? #include int main() { int a[5] = {1,2,3,4,5}; int p = (int)(&amp;a + 1); printf(&quot;%d, %dn&quot;, *(a + 1), *(p -1)); } 解决方案 int a[5] = {1,2,3,4,5}; int* p = (int*)(&amp;a + 1); printf(&quot;%d, %dn&quot;, *(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/wzVQnKp.html" rel="bookmark">jquery-jQuery一个小知识点，求教</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 jQuery一个小知识点,求教 本来不想麻烦大神的,今天看视频教程$().ready(function(){ }); 和$(document).ready(function(){ });我百度了没有明确结果,希望比较懂Js的大神告诉我一声,这两个是不是一样的 解决方案 两者效果是一样的,当没有写document的时候,默认就是选中document$().ready(function () { } )与javascript中的onload=function ( ){ };效果也是一样的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM60ENz.html" rel="bookmark">vb编程-用vb。net设计一个小游戏</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 用vb.net设计一个小游戏 我想实现以下功能: 当单击某一个按钮时,如果其他按钮的颜色和这个按钮相同,则让这两个按钮消失,该怎么判断那个按钮是否和本按钮的颜色相同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvYdAb.html" rel="bookmark">ttl-关于ip归属地的一个小问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于ip归属地的一个小问题 IP归属地 美国 内华达州克拉克县亨德森市Enzu ip归属地 可以看出来是 内华达州的,但是enzu的怎么看出来的? 能不能在ping的时候不出现这个 &quot;enzu&quot; 解决方案 两个可能,一个是网站为了防止非法复制和盗取,在后面加上的随机文字 一个是真的有Enzu,不知道是不是一个地名 你可以用正则表达式过滤. 解决方案二: 那就是数据库里记录的,这个就好比根据一个电话,你能知道大概在哪个城市,但是公安局可以知道开户的户主叫什么. 这不是技术问题.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boq1Vp.html" rel="bookmark" class="title">Hibernate主键生成方式 Key Generator</a>
					<div>
						Hibernate主键生成方式 Key Generator 主键产生器 可选项说明: 1) assigned 主键由外部程序负责生成,无需Hibernate参与. 2) hilo 通过hi/lo 算法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3qlwp.html" rel="bookmark" class="title">存储过程中建立一个表时出错，为什么？</a>
					<div>
						存储过程 存储过程如下:create or replace procedure proc_tmp is   dynamic_sql varchar2(100);begin  dynamic_sql : ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqjYap.html" rel="bookmark" class="title">State模式在J2ME游戏设计中的应用（需要源代码留下e-mail）</a>
					<div>
						设计|源代码    游戏设计中的状态转换是一个既是非常重要又十分复杂的部分.我前几天做移植的时候看到一个public void keyPressed(int keyCode)中间竟然有着近2000千行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4477p.html" rel="bookmark" class="title">php获取字符串的长度及截取字符串</a>
					<div>
						三.获取字符串的长度:strlen()函数 语法: int strlen(string str); 例: &lt;?php echo strlen(&quot;www.bianceng.cn&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M913wVM.html" rel="bookmark" class="title">c&num;将Excel数据导入到数据库的实现代码</a>
					<div>
						 这篇文章主要介绍了c#将Excel数据导入到数据库的实现代码,有需要的朋友可以参考一下 假如Excel中的数据如下:     数据库建表如下:     其中Id为自增字段:     代码:      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPnOBM.html" rel="bookmark" class="title">jQuery插件Tmpl的简单使用方法</a>
					<div>
						  JavaScript 也可以利用模版来解决这些问题,比如基于 jQuery 的 jquery.tmpl,现在已经被接受为官方的模版插件了.详细的 API 在 jQuery 的 Templates  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLay18z.html" rel="bookmark" class="title">电脑开机黑屏只有鼠标怎么办</a>
					<div>
						  有如下的解决办法: 一.最简单,重启下电脑,进系统黑屏只是偶尔的问题. 二.重启电脑,启动的时候连按F8键进入安全模式看能进去不,把刚才重启前出问题的时候装的软件什么的取消启动或者删除,如果是杀软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWD3Ap.html" rel="bookmark" class="title">U盘分区格式如何转换</a>
					<div>
						  大于4G的单个文件是无法装在FAT格式的U盘上的,只有在NTFS的格式下才可以. 那么下面就展示给大家两个方法更改U盘格式: 打开我的电脑,找到你的U盘,右键U盘选择&quot;属性&quot;- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQkAnp.html" rel="bookmark" class="title">css-关于div布局问题，怎样使div大小不随浏览器窗口大小改变</a>
					<div>
						问题描述 关于div布局问题,怎样使div大小不随浏览器窗口大小改变 &lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6DRAb.html" rel="bookmark" class="title">&lbrack;网站搭建&rsqb; 阿里云虚拟主机搭建及FTP文件上传</a>
					<div>
						        写这篇文章主要有两个原因:一方面是得到了阿里云的一个&quot;开通码&quot;,另一方面是最近给学生们上网站制作的课程,想把学生们提交的作业上传到服务器上去,让他们体会一下自己做的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZE81ap.html" rel="bookmark" class="title">使用trash-cli避免误删文件--为rm增加回收站功能</a>
					<div>
						问题 相信有不少同学和我一样,有因习惯了rm命令,好几次一不小心冲动就删除重要文件的惨痛经历. 像这种使用 rm 命令误删除文件的情况,我们会注意,但是我们不能保证百分百的不会 出现这种情况,毕竟事情 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPGevp.html" rel="bookmark" class="title">创新、风险与监管：什么才是新金融模式？&vert; 新浪C&plus;</a>
					<div>
						第二届新浪C+峰会今天上午在北京正式开幕.在上午的金融科技论坛中,嘉宾围绕新金融模式的创新.风险与监管等问题展开讨论.其中英凡研究院副院长杜艳担任论坛主持人,参与讨论的嘉宾包括社科院金融所所长助理杨涛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAV93M.html" rel="bookmark" class="title">哥哥姐姐们好，我有个关于android源码蓝牙的问题！求解。。。</a>
					<div>
						问题描述 哥哥姐姐们好,我有个关于android源码蓝牙的问题!求解... 我现在有个需求就是 在android源码中修改蓝牙默认名称,在网上查了好久, &quot; frameworksasecor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn710Wz.html" rel="bookmark" class="title">苹果日前宣布，将旗下移动广告平台iAd的最低收费门槛降低</a>
					<div>
						苹果日前宣布,将旗下移动广告平台iAd的最低收费门槛从100万美元降至50万美元,以增加iAd对小型广告主的吸引力.iAd刚推出时的最低准入门槛是100万美元,对一个刚起步的平台而言,这样的价格让人望 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqN4jz.html" rel="bookmark" class="title">八年了必须放手了，我不是你妈妈</a>
					<div>
						谨以此文悼念自己的坚持了8年的初恋以及逝去的青春.       晚上七点,写完日报,上传今天更新的代码.简单的收拾,挤上了回家的地铁,天气慢慢变热了,地铁中的味道也丰富了起来.站在角落,拿出手机,也就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmK375b.html" rel="bookmark" class="title">web打印控件问题&comma;大虾进</a>
					<div>
						问题描述 要求:使用控件的工具,一般提供了表单创建的工具,可以生成一个服务器端的文件然后控件安装在客户端两个东西会通信,客户机的打印无需浏览器,直接控件完成.有没有这种东西					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNLQGM.html" rel="bookmark" class="title">将人工智能探灯，照向一望无际的数据深海 &vert; KDD China技术峰会预告</a>
					<div>
						如果把人工智能比作翻滚而来的巨浪, 那么数据, 就是蕴藏在浪头底下遥远深邃的大海. 良性运转的人工智能平台,是一种通过数据.技术.产品三者不断循环,完成的滚雪球式闭环. 12 月 18 日, ACM  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR3NOp.html" rel="bookmark" class="title">用js实现选项卡功能。。。</a>
					<div>
						问题描述 用js实现选项卡功能... 怎么实现点击哪个出现相关的品牌 求js 解决方案 这个什么意思,如果是点击上面蓝色字就出现相关品牌的话就用超链接就可以了: 如果是点击字母就显示以这个字母为首的品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQKRBp.html" rel="bookmark" class="title">Swift游戏实战-跑酷熊猫 08 产生源源不断的移动平台</a>
					<div>
						原文:Swift游戏实战-跑酷熊猫 08 产生源源不断的移动平台 原理   代码实现   这节内容我们一起学习下平台的生产算法. 要点: 何时生成新的平台: 当上一个平台的右边完全进入场景的时候,就可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2O5az.html" rel="bookmark" class="title">立思辰：办公信息系统服务第一品牌</a>
					<div>
						艾经纬 立思辰(300010.SZ)发行价为18元.2006年~2008年http://www.aliyun.com/zixun/aggregation/32902.html&quot;&gt;营业收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7E2Qb.html" rel="bookmark" class="title">PHP类的静态&lpar;static&rpar;方法和静态&lpar;static&rpar;变量使用介绍&lowbar;php技巧</a>
					<div>
						在php中,访问类的方法/变量有两种方法: 1. 创建对象$object = new Class(),然后使用&quot;-&gt;&quot;调用:$object-&gt;attribute/fun ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2g1jM.html" rel="bookmark" class="title">Jquery选择器中使用变量实现动态选择例子&lowbar;jquery</a>
					<div>
						例子一: &lt;table&gt; &lt;tr&gt; &lt;th&gt;用户名&lt;/th&gt; &lt;th&gt;状态&lt;/th&gt; &lt;tr&gt; &lt;tr&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Zmnvb.html" rel="bookmark" class="title">使用jquery解析XML示例代码&lowbar;jquery</a>
					<div>
						xml文件结构:books.xml &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;root&gt; &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NeKop.html" rel="bookmark" class="title">请教高手：new String&lpar;byte&rpar;&period;getBytes&lpar;&rpar; 与 byte&period;clone&lpar;&rpar; 得到的Byte有啥区别</a>
					<div>
						问题描述 在做加密解密时发现将加密后的Byte转成String后再转回Byte 不能正常解密抛出 javax.crypto.IllegalBlockSizeException: Input lengt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6232M.html" rel="bookmark" class="title">Android-电话录音服务</a>
					<div>
						Android-电话录音 TelephonyManager telManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2N9Oz.html" rel="bookmark" class="title">传闻再起&OpenCurlyDoubleQuote;核高基&rdquo;名单近期有望出台中国软件涨停</a>
					<div>
						每经记者 宋元东 &quot;核高基&quot;名单即将出炉的消息昨日再度传出,相关概念股闻风而动,头号概念股中国软件以 涨停收盘.一家参与项目申报的公司负责人向&lt;每日经济新闻&gt;透露,首批 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NXR4b.html" rel="bookmark" class="title">FCKeditor文本颜色设置无效</a>
					<div>
						问题描述 在FCKeditor编辑器内获取到所有文本(有设置颜色和字体),修改时候也能在编辑器内显示,但在前台用Label,span等都只显示文字,不能正确显示文本的颜色和字体,等于颜色和字体设置无效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0YJyz.html" rel="bookmark" class="title">make&colon; &ast;&ast;&ast; &lbrack;ext&sol;gd&sol;libgd&sol;gd&lowbar;compat&period;lo&rsqb; Error 1</a>
					<div>
						升级系统,把php5.2.9升级到5.3.6,按照以前的编译参数,configure能正常通过,但是在make的时候提示: In file included from /root/php-5.3.6/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYw6Wb.html" rel="bookmark" class="title">关于线程的wait&lpar;&rpar;&plus;notify&lpar;&rpar;&comma;以及过时的suspend&lpar;&rpar;&plus;resum&lpar;&rpar;的问题，先谢谢大家的解答了</a>
					<div>
						问题描述 这是一个实验题目,编写一个小程序,要求是这样的:这个是我的源代码:importjava.awt.*;importjava.awt.event.*;publicclassTestSquareC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNmY0Nb.html" rel="bookmark" class="title">平安城市建设之车辆大数据的市场应用现状</a>
					<div>
						随着我国经济的快速发展,城市机动车保有量正在持续的增加,这不仅加大了交通管理的难度,而且涉车涉驾的案件比例也不断上升,特别是盗抢机动车辆.机动车肇事逃逸以及涉车类刑事案件,严重影响了社会治安状况,损害 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
